﻿Type=Service
Version=1.60
StartAtBoot=False
@EndOfDesignText@
'Service module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Dim rv As RemoteViews
End Sub
Sub Service_Create
	' Configure the homescreen widget. We let it update every 2 hours here. This is
	' normally not necessary but I want to be sure that the clock restarts if there
	' is any problem.
	rv = ConfigureHomeWidget("l2x1", "rv", 120, "AmberHome Minimalistic Clock")
End Sub

Sub Service_Start (StartingIntent As Intent)
	' If a widget is removed from homescreen we don't need to do anything
	If StartingIntent.Action = "android.appwidget.action.APPWIDGET_DELETED" Then Return
	
	' Handle the widget events (RequestUpdate and Disabled)
	If rv.HandleWidgetEvents(StartingIntent) = False Then
		' If the action is not handled by HandleWidgetEvents() then we
		' probably were called by StartService() or StartServiceAt().
		' So just update the widget.
		rv_RequestUpdate
	End If
	
	' We have to be sure that we do not start the service
	' again if all widgets are removed from homescreen
	If StartingIntent.Action <> "android.appwidget.action.APPWIDGET_DISABLED" Then
		StartServiceAt("", TimeToNextMinute, False)
	End If
End Sub

Sub rv_RequestUpdate
	' Just update the time on the widget
	DateTime.TimeFormat = "HH:mm"
	rv.SetText("lClock", DateTime.Time(DateTime.Now))
	rv.UpdateWidget
End Sub

Sub rv_Disabled
	' If all widgets are removed from homescreen cancel the next schedule and
	' stop the service
	CancelScheduledService("")
	StopService("")
End Sub

Sub Service_Destroy

End Sub

Sub TimeToNextMinute As Long
	Dim ret As Long

	ret = DateTime.Now + DateTime.TicksPerMinute
	ret = ret - (ret Mod DateTime.TicksPerMinute)	
	Return ret
End Sub